"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toAxiosRequestConfig = exports.fromAxiosResponse = void 0;
/**
 * Convert AxiosResponse<string> to Response
 *
 * @param axiosResponse
 */
function fromAxiosResponse(axiosResponse) {
    var responseHeaders = [];
    for (var _i = 0, _a = Object.keys(axiosResponse.headers); _i < _a.length; _i++) {
        var key = _a[_i];
        responseHeaders.push({ key: key, value: axiosResponse.headers[key] });
    }
    var response = {
        status: axiosResponse.status,
        statusText: axiosResponse.statusText,
        headers: responseHeaders,
    };
    // encode bytes as base64 string if response is array buffer
    if (axiosResponse.config.responseType == "arraybuffer") {
        return __assign(__assign({}, response), { body: Buffer.from(axiosResponse.data).toString("base64") });
    }
    else {
        return __assign(__assign({}, response), { body: axiosResponse.data });
    }
}
exports.fromAxiosResponse = fromAxiosResponse;
/**
 * Creates AxiosRequestConfig from Request
 *
 * @param request
 */
function toAxiosRequestConfig(request) {
    var _a, _b;
    var urlParams = (_a = request.urlParams) === null || _a === void 0 ? void 0 : _a.reduce(function (params, p) {
        var _a;
        return __assign(__assign({}, params), (_a = {}, _a[p.key] = p.value, _a));
    }, {});
    var requestHeaders = (_b = request.headers) === null || _b === void 0 ? void 0 : _b.reduce(function (headers, h) {
        var _a;
        return __assign(__assign({}, headers), (_a = {}, _a[h.key] = h.value, _a));
    }, {});
    var config = {
        responseType: request.responseType == "BINARY" ? "arraybuffer" : "text",
    };
    if (urlParams) {
        config = __assign(__assign({}, config), { params: urlParams });
    }
    if (requestHeaders) {
        config = __assign(__assign({}, config), { headers: requestHeaders });
    }
    return config;
}
exports.toAxiosRequestConfig = toAxiosRequestConfig;
//# sourceMappingURL=util.js.map